#ifndef SUBDIVISION_H
#define SUBDIVISION_H

#include <QtOpenGL>
#include <QOpenGLFunctions_4_3_Core>

#include "mesh.h"

class Subdivision
{
public:
    Subdivision(QOpenGLFunctions_4_3_Core *f);
    ~Subdivision();

    void init();
    Mesh *subdivide(Mesh *mesh);

private:
    struct Input
    {
        GLuint vb_handle;
        QVector<unsigned int> index_buffer;
        QVector<Vertex> vertex_buffer;
    };

    struct Tables
    {
        QVector<GLuint> edge_indices;
        QVector<GLuint> vertex_indices;
        QVector<GLuint> vertex_offsets;
    };

    QOpenGLFunctions_4_3_Core *f;
    QOpenGLShaderProgram *edgeShader;

    QOpenGLShaderProgram *initComputeShaderProgram(QString &source);
    Tables precomputeTables(Input input);
    void runShader(Input input, Tables &tables);
};

#endif
